local lib = LibIJA
local internal = lib.internal

local POTIONTRAIT_RESTOREHEALTH			= 1
local POTIONTRAIT_RAVAGEHEALTH			= 2
local POTIONTRAIT_RESTOREMAGICKA		= 3
local POTIONTRAIT_RAVAGEMAGICKA			= 4
local POTIONTRAIT_RESTORESTAMINA		= 5
local POTIONTRAIT_RAVAGESTAMINA			= 6
local POTIONTRAIT_SPELLRESIST			= 7
local POTIONTRAIT_BREACH				= 8
local POTIONTRAIT_LOWERSPELLRESIST		= 8
local POTIONTRAIT_ARMOR 				= 9
local POTIONTRAIT_PHYSICALRESIST		= 9
local POTIONTRAIT_FRACTURE				= 10
local POTIONTRAIT_LOWERARMOR			= 10
local POTIONTRAIT_LOWERPHYSICALRESIST	= 10
local POTIONTRAIT_SPELLPOWER			= 11
local POTIONTRAIT_LOWERSPELLPOWER		= 12
local POTIONTRAIT_COWARDICE				= 12
local POTIONTRAIT_WEAPONPOWER			= 13
local POTIONTRAIT_MAIM					= 14
local POTIONTRAIT_LOWERWEAPONPOWER		= 14
local POTIONTRAIT_SPELLCRIT				= 15
local POTIONTRAIT_UNCERTAINTY			= 16
local POTIONTRAIT_LOWERSPELLCRIT		= 16
local POTIONTRAIT_WEAPONCRIT			= 17
local POTIONTRAIT_ENERVATION			= 18
local POTIONTRAIT_LOWERWEAPONCRIT		= 18
local POTIONTRAIT_UNSTOPPABLE			= 19
local POTIONTRAIT_STUN					= 20
local POTIONTRAIT_DETECTION				= 21
local POTIONTRAIT_INVISIBLE				= 22
local POTIONTRAIT_SPEED					= 23
local POTIONTRAIT_HINDRANCE				= 24
local POTIONTRAIT_SLOW					= 24
local POTIONTRAIT_REDUCESPEED			= 24
local POTIONTRAIT_PROTECTION			= 25
local POTIONTRAIT_VULNERABILITY			= 26
local POTIONTRAIT_SUSTAINRESTOREHEALTH	= 27
local POTIONTRAIT_GRADUALRAVAGEHEALTH	= 28
local POTIONTRAIT_CREEPINGRAVAGEHEALTH	= 28
local POTIONTRAIT_VITALITY				= 29
local POTIONTRAIT_DEFILE				= 30
local POTIONTRAIT_HEROISM				= 31
local POTIONTRAIT_TIMIDITY				= 32

-------------------------------------
-- 
-------------------------------------
internal.POTIONTRAIT_DATA = {
	[1] = {
		["id"] 				= 1,
		["oppositeId"] 		= 2,
		["potionBaseId"]	= 54339,
		["poisonBaseId"]	= 76826,
		["isPositive"] 		= true,
		["index"] 			= 18,
	},
	[2] = {
		["id"] 				= 2,
		["oppositeId"] 		= 1,
		["potionBaseId"]	= 44812,
		["poisonBaseId"]	= 76827,
		["isPositive"] 		= false,
		["index"] 			= 5,
	},
	[3] = {
		["id"] 				= 3,
		["oppositeId"] 		= 4,
		["potionBaseId"]	= 54340,
		["poisonBaseId"]	= 76828,
		["isPositive"] 		= true,
		["index"] 			= 19,
	},
	[4] = {
		["id"] 				= 4,
		["oppositeId"] 		= 3,
		["potionBaseId"]	= 44815,
		["poisonBaseId"]	= 76829,
		["isPositive"] 		= false,
		["index"] 			= 6,
	},
	[5] = {
		["id"] 				= 5,
		["oppositeId"] 		= 6,
		["potionBaseId"]	= 54341,
		["poisonBaseId"]	= 76830,
		["isPositive"] 		= true,
		["index"] 			= 20,
	},
	[6] = {
		["id"] 				= 6,
		["oppositeId"] 		= 5,
		["potionBaseId"]	= 44809,
		["poisonBaseId"]	= 76831,
		["isPositive"] 		= false,
		["index"] 			= 7,
	},
	[7] = {
		["id"] 				= 7,
		["oppositeId"] 		= 8,
		["potionBaseId"]	= 44814,
		["poisonBaseId"]	= 76832,
		["isPositive"] 		= true,
		["index"] 			= 23,
	},
	[8] = {
		["id"] 				= 8,
		["oppositeId"] 		= 7,
		["potionBaseId"]	= 44821,
		["poisonBaseId"]	= 76833,
		["isPositive"] 		= false,
		["index"] 			= 25,
	},
	[9] = {
		["id"] 				= 9,
		["oppositeId"] 		= 10,
		["potionBaseId"]	= 27042,
		["poisonBaseId"]	= 76837,
		["isPositive"]		= true,
		["index"] 			= 24,
	},
	[10] = {
		["id"] 				= 10,
		["oppositeId"] 		= 9,
		["potionBaseId"]	= 27040,
		["poisonBaseId"]	= 76835,
		["isPositive"] 		= false,
		["index"] 			= 26,
	},
	[11] = {
		["id"] 				= 11,
		["oppositeId"] 		= 12,
		["potionBaseId"]	= 30145,
		["poisonBaseId"]	= 76840,
		["isPositive"] 		= true,
		["index"] 			= 12,
	},
	[12] = {
		["id"] 				= 12,
		["oppositeId"] 		= 11,
		["potionBaseId"]	= 44813,
		["poisonBaseId"]	= 76834,
		["isPositive"] 		= false,
		["index"] 			= 14,
	},
	[13] = {
		["id"] 				= 13,
		["oppositeId"] 		= 14,
		["potionBaseId"]	= 44714,
		["poisonBaseId"]	= 76838,
		["isPositive"] 		= true,
		["index"] 			= 13,
	},
	[14] = {
		["id"] 				= 14,
		["oppositeId"] 		= 13,
		["potionBaseId"]	= 44810,
		["poisonBaseId"]	= 76839,
		["isPositive"] 		= false,
		["index"] 			= 15,
	},
	[15] = {
		["id"] 				= 15,
		["oppositeId"] 		= 16,
		["potionBaseId"]	= 30141,
		["poisonBaseId"]	= 76836,
		["isPositive"] 		= true,
		["index"] 			= 16,
	},
	[16] = {
		["id"] 				= 16,
		["oppositeId"] 		= 15,
		["potionBaseId"]	= 54336,
		["poisonBaseId"]	= 76841,
		["isPositive"] 		= false,
		["index"] 			= 8,
	},
	[17] = {
		["id"] 				= 17,
		["oppositeId"] 		= 18,
		["potionBaseId"]	= 30146,
		["poisonBaseId"]	= 76842,
		["isPositive"] 		= true,
		["index"] 			= 17,
	},
	[18] = {
		["id"] 				= 18,
		["oppositeId"] 		= 17,
		["potionBaseId"]	= 54337,
		["poisonBaseId"]	= 76843,
		["isPositive"] 		= false,
		["index"] 			= 9,
	},
	[19] = {
		["id"] 				= 19,
		["oppositeId"] 		= 20,
		["potionBaseId"]	= 27039,
--		["poisonBaseId"]	= 81196,
		["poisonBaseId"]	= 76847,
		["isPositive"] 		= true,
		["index"] 			= 2,
	},
	[20] = {
		["id"] 				= 20,
		["oppositeId"] 		= 19,
		["potionBaseId"]	= 54333,
		["poisonBaseId"]	= 76845,
		["isPositive"] 		= false,
		["index"] 			= 4,
	},
	[21] = {
		["id"] 				= 21,
		["oppositeId"] 		= 22,
		["potionBaseId"]	= 30142,
		["poisonBaseId"]	= 76846,
		["isPositive"] 		= true,
		["index"] 			= 3,
	},
	[22] = {
		["id"] 				= 22,
		["oppositeId"] 		= 21,
		["potionBaseId"]	= 44715,
		["poisonBaseId"]	= 76844,
		["isPositive"] 		= true,
		["index"] 			= 10,
	},
	[23] = {
		["id"] 				= 23,
		["oppositeId"] 		= 24,
		["potionBaseId"]	= 27041,
		["poisonBaseId"]	= 76848,
		["isPositive"] 		= true,
		["index"] 			= 11,
	},
	[24] = {
		["id"] 				= 24,
		["oppositeId"] 		= 23,
		["potionBaseId"]	= 54335,
		["poisonBaseId"]	= 81196, --76849?
		["isPositive"] 		= false,
		["index"] 			= 1,
	},
	[25] = {
		["id"] 				= 25,
		["oppositeId"] 		= 26,
		["potionBaseId"]	= 77596,
		["poisonBaseId"]	= 77597,
		["isPositive"] 		= true,
		["index"] 			= 27,
	},
	[26] = {
		["id"] 				= 26,
		["oppositeId"] 		= 25,
		["potionBaseId"]	= 77598,
		["poisonBaseId"]	= 77599,
		["isPositive"] 		= false,
		["index"] 			= 28,
	},
	[27] = {
		["id"] 				= 27,
		["oppositeId"] 		= 28,
		["potionBaseId"]	= 77592,
		["poisonBaseId"]	= 77593,
		["isPositive"] 		= true,
		["index"] 			= 21,
	},
	[28] = {
		["id"] 				= 28,
		["oppositeId"] 		= 27,
		["potionBaseId"]	= 77594,
		["poisonBaseId"]	= 81195, --77595?
		["isPositive"] 		= false,
		["index"] 			= 22,
			},
	[29] = {
		["id"] 				= 29,
		["oppositeId"] 		= 30,				
		["potionBaseId"]	= 77600,
		["poisonBaseId"]	= 77601,
		["isPositive"] 		= true,
		["index"] 			= 29,
			},
	[30] = {
		["id"] 				= 30,
		["oppositeId"] 		= 29,
		["potionBaseId"] 	= 77602,
		["poisonBaseId"] 	= 77603,
		["isPositive"] 		= false,
		["index"] 			= 30,
	},
	[31] = {
		["id"] 				= 31,
		["oppositeId"] 		= 32,
		["potionBaseId"] 	= 151969,
		["poisonBaseId"] 	= 152151,
		["isPositive"] 		= true,
		["index"] 			= 31,
	},
	[32] = {
		["id"] 				= 32,
		["oppositeId"] 		= 31,
		["potionBaseId"] 	= 151969,
		["poisonBaseId"] 	= 152151,
		["isPositive"] 		= false,
		["index"] 			= 32,
	}
}
internal.REAGENT_DATA = {
	[30148] = {
		["itemId"]	= 30148,
		["traits"]	= {[POTIONTRAIT_RAVAGEMAGICKA] = true, [POTIONTRAIT_LOWERSPELLPOWER] = true, [POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_INVISIBLE] = true},
	},
	[30149] = {
		["itemId"]	= 30149,
		["traits"]	= {[POTIONTRAIT_LOWERARMOR] = true, [POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_WEAPONPOWER] = true, [POTIONTRAIT_RAVAGESTAMINA] = true},
	},
	[30151] = {
		["itemId"]	= 30151,
		["traits"]	= {[POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_RAVAGEMAGICKA] = true, [POTIONTRAIT_RAVAGESTAMINA] = true, [POTIONTRAIT_STUN] = true},
	},
	[30152] = {
		["itemId"]	= 30152,
		["traits"] 	= {[POTIONTRAIT_LOWERSPELLRESIST] = true, [POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_SPELLPOWER] = true, [POTIONTRAIT_RAVAGEMAGICKA] = true},
	},
	[30153] = {
		["itemId"]	= 30153,
		["traits"] 	= {[POTIONTRAIT_SPELLCRIT] = true, [POTIONTRAIT_SPEED] = true, [POTIONTRAIT_INVISIBLE] = true, [POTIONTRAIT_UNSTOPPABLE] = true},
	},
	[30154] = {
		["itemId"]	= 30154,
		["traits"] 	= {[POTIONTRAIT_LOWERSPELLPOWER] = true, [POTIONTRAIT_RAVAGEMAGICKA] = true, [POTIONTRAIT_SPELLRESIST] = true, [POTIONTRAIT_DETECTION] = true},
	},
	[30155] = {
		["itemId"]	= 30155,
		["traits"] 	= {[POTIONTRAIT_RAVAGESTAMINA] = true, [POTIONTRAIT_LOWERWEAPONPOWER] = true, [POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_REDUCESPEED] = true},
	},
	[30156] = {
		["itemId"]	= 30156,
		["traits"] 	= {[POTIONTRAIT_LOWERWEAPONPOWER] = true, [POTIONTRAIT_RAVAGESTAMINA] = true, [POTIONTRAIT_ARMOR] = true, [POTIONTRAIT_LOWERWEAPONCRIT] = true},
	},
	[30157] = {
		["itemId"]	= 30157,
		["traits"]	= {[POTIONTRAIT_RESTORESTAMINA] = true, [POTIONTRAIT_WEAPONPOWER] = true, [POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_SPEED] = true},
	},
	[30158] = {
		["itemId"]	= 30158,
		["traits"] 	= {[POTIONTRAIT_SPELLPOWER] = true, [POTIONTRAIT_RESTOREMAGICKA] = true, [POTIONTRAIT_LOWERSPELLRESIST] = true, [POTIONTRAIT_SPELLCRIT] = true},
	},
	[30159] = {
		["itemId"]	= 30159,
		["traits"] 	= {[POTIONTRAIT_WEAPONCRIT] = true, [POTIONTRAIT_REDUCESPEED] = true, [POTIONTRAIT_DETECTION] = true, [POTIONTRAIT_UNSTOPPABLE] = true},
	},
	[30160] = {
		["itemId"]	= 30160,
		["traits"]	= {[POTIONTRAIT_SPELLRESIST] = true, [POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_LOWERSPELLPOWER] = true, [POTIONTRAIT_RESTOREMAGICKA] = true},
	},
	[30161] = {
		["itemId"]	= 30161,
		["traits"]	= {[POTIONTRAIT_RESTOREMAGICKA] = true, [POTIONTRAIT_SPELLPOWER] = true, [POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_DETECTION] = true},
	},
	[30162] = {
		["itemId"]	= 30162,
		["traits"] 	= {[POTIONTRAIT_WEAPONPOWER] = true, [POTIONTRAIT_RESTORESTAMINA] = true, [POTIONTRAIT_LOWERARMOR] = true, [POTIONTRAIT_WEAPONCRIT] = true},
	},
	[30163] = {
		["itemId"]	= 30163,
		["traits"] 	= {[POTIONTRAIT_ARMOR] = true, [POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_LOWERWEAPONPOWER] = true, [POTIONTRAIT_RESTORESTAMINA] = true},
	},
	[30164] = {
		["itemId"]	= 30164,
		["traits"]	= {[POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_RESTOREMAGICKA] = true, [POTIONTRAIT_RESTORESTAMINA] = true, [POTIONTRAIT_UNSTOPPABLE] = true},
	},
	[30165] = {
		["itemId"]	= 30165,
		["traits"] 	= {[POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_LOWERSPELLCRIT] = true, [POTIONTRAIT_LOWERWEAPONCRIT] = true, [POTIONTRAIT_INVISIBLE] = true},
	},
	[30166] = {
		["itemId"]	= 30166,
		["traits"] 	= {[POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_SPELLCRIT] = true, [POTIONTRAIT_WEAPONCRIT] = true, [POTIONTRAIT_STUN] = true},
	},
	[77581] = {
		["itemId"]	= 77581,
		["traits"] 	= {[POTIONTRAIT_LOWERARMOR] = true, [POTIONTRAIT_LOWERWEAPONCRIT] = true, [POTIONTRAIT_DETECTION] = true, [POTIONTRAIT_VITALITY] = true},
	},
	[77583] = {
		["itemId"]	= 77583,
		["traits"]	= {[POTIONTRAIT_BREACH] = true, [POTIONTRAIT_ARMOR] = true, [POTIONTRAIT_PROTECTION] = true, [POTIONTRAIT_VITALITY] = true},
	},
	[77584] = {
		["itemId"]	= 77584,
		["traits"] 	= {[POTIONTRAIT_REDUCESPEED] = true, [POTIONTRAIT_INVISIBLE] = true, [POTIONTRAIT_SUSTAINRESTOREHEALTH] = true, [POTIONTRAIT_DEFILE] = true},
	},
	[77585] = {
		["itemId"]	= 77585,
		["traits"]	= {[POTIONTRAIT_RESTOREHEALTH] = true, [POTIONTRAIT_LOWERSPELLCRIT] = true, [POTIONTRAIT_SUSTAINRESTOREHEALTH] = true, [POTIONTRAIT_VITALITY] = true},
	},
	[77587] = {
		["itemId"]	= 77587,
		["traits"] 	= {[POTIONTRAIT_RAVAGESTAMINA] = true, [POTIONTRAIT_VULNERABILITY] = true, [POTIONTRAIT_CREEPINGRAVAGEHEALTH] = true, [POTIONTRAIT_VITALITY] = true},
	},
	[77589] = {
		["itemId"]	= 77589,
		["traits"] 	= {[POTIONTRAIT_RAVAGEMAGICKA] = true, [POTIONTRAIT_SPEED] = true, [POTIONTRAIT_VULNERABILITY] = true, [POTIONTRAIT_SUSTAINRESTOREHEALTH] = true},
	},
	[77590] = {
		["itemId"]	= 77590,
		["traits"] 	= {[POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_PROTECTION] = true, [POTIONTRAIT_CREEPINGRAVAGEHEALTH] = true, [POTIONTRAIT_DEFILE] = true},
	},
	[77591] = {
		["itemId"]	= 77591,
		["traits"] 	= {[POTIONTRAIT_SPELLRESIST] = true, [POTIONTRAIT_ARMOR] = true, [POTIONTRAIT_PROTECTION] = true, [POTIONTRAIT_DEFILE] = true},
	},
	[139019] = {
		["itemId"]	= 139019,
		["traits"] 	= {[POTIONTRAIT_SUSTAINRESTOREHEALTH] = true, [POTIONTRAIT_SPEED] = true, [POTIONTRAIT_VITALITY] = true, [POTIONTRAIT_PROTECTION] = true},
	},
	[139020] = {
		["itemId"]	= 139020,
		["traits"]	= {[POTIONTRAIT_SPELLRESIST] = true, [POTIONTRAIT_HINDRANCE] = true, [POTIONTRAIT_VULNERABILITY] = true, [POTIONTRAIT_DEFILE] = true},
	},
	[150669] = {
		["itemId"]	= 150669,
		["traits"]	= {[POTIONTRAIT_TIMIDITY] = true, [POTIONTRAIT_RAVAGEMAGICKA] = true, [POTIONTRAIT_RESTORESTAMINA] = true, [POTIONTRAIT_DETECTION] = true},
	},
	[150670] = {
		["itemId"]	= 150670,
		["traits"] 	= {[POTIONTRAIT_TIMIDITY] = true, [POTIONTRAIT_RAVAGEHEALTH] = true, [POTIONTRAIT_RESTOREMAGICKA] = true, [POTIONTRAIT_PROTECTION] = true},
	},
	[150671] = {
		["itemId"]	= 150671,
		["traits"]	= {[POTIONTRAIT_RESTOREMAGICKA] = true, [POTIONTRAIT_HEROISM] = true, [POTIONTRAIT_ENERVATION] = true, [POTIONTRAIT_SPEED] = true},
	},
	[150672] = {
		["itemId"]	= 150672,
		["traits"]	= {[POTIONTRAIT_TIMIDITY] = true, [POTIONTRAIT_SPELLCRIT] = true, [POTIONTRAIT_GRADUALRAVAGEHEALTH] = true, [POTIONTRAIT_RESTOREHEALTH] = true},
	},
	[150731] = {
		["itemId"]	= 150731,
		["traits"]	= {[POTIONTRAIT_SUSTAINRESTOREHEALTH] = true, [POTIONTRAIT_RESTORESTAMINA] = true, [POTIONTRAIT_HEROISM] = true, [POTIONTRAIT_DEFILE] = true},
	},
	[150789] = {
		["itemId"]	= 150789,
		["traits"]	= {[POTIONTRAIT_HEROISM] = true, [POTIONTRAIT_VULNERABILITY] = true, [POTIONTRAIT_INVISIBLE] = true, [POTIONTRAIT_VITALITY] = true},
	}
}
internal.SOLVENT_DATA = {
	[883] = {
		["level"] 			= 3,
		["itemId"] 			= 883,
		["internalLevel"]	= 3,
		["internalType"]	= 30,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:883:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[1187] = {
		["level"] 			= 10,
		["itemId"] 			= 1187,
		["internalLevel"]	= 10,
		["internalType"]	= 30,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:1187:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[4570] = {
		["level"] 			= 20,
		["itemId"] 			= 4570,
		["internalLevel"]	= 20,
		["internalType"]	= 30,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:4570:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[23265] = {
		["level"] 			= 30,
		["itemId"] 			= 23265,
		["internalLevel"]	= 30,
		["internalType"]	= 30,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:23265:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[23266] = {
		["level"] 			= 40,
		["itemId"] 			= 23266,
		["internalLevel"]	= 40,
		["internalType"]	= 30,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:23266:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[23267] = {
		["level"] 			= 51,
		["itemId"] 			= 23267,
		["internalLevel"]	= 50,
		["internalType"]	= 125,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:23267:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[23268] = {
		["level"] 			= 55,
		["itemId"] 			= 23268,
		["internalLevel"]	= 50,
		["internalType"]	= 129,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:23268:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[64500] = {
		["level"] 			= 60,
		["itemId"] 			= 64500,
		["internalLevel"]	= 50,
		["internalType"]	= 134,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:64500:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[64501] = {
		["level"] 			= 65,
		["itemId"] 			= 64501,
		["internalLevel"]	= 50,
		["internalType"]	= 308,
		["isPoison"] 		= false,
		["itemLink"]		= "|H0:item:64501:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	
	[75357] = {
		["level"] 			= 3,
		["itemId"] 			= 75357,
		["internalLevel"]	= 3,
		["internalType"]	= 30,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75357:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75358] = {
		["level"] 			= 10,
		["itemId"] 			= 75358,
		["internalLevel"]	= 10,
		["internalType"]	= 30,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75358:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75359] = {
		["level"] 			= 20,
		["itemId"] 			= 75359,
		["internalLevel"]	= 20,
		["internalType"]	= 30,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75359:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75360] = {
		["level"] 			= 30,
		["itemId"] 			= 75360,
		["internalLevel"]	= 30,
		["internalType"]	= 30,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75360:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75361] = {
		["level"] 			= 40,
		["itemId"] 			= 75361,
		["internalLevel"]	= 40,
		["internalType"]	= 30,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75361:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75362] = {
		["level"] 			= 51,
		["itemId"] 			= 75362,
		["internalLevel"]	= 50,
		["internalType"]	= 125,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75362:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75363] = {
		["level"] 			= 55,
		["itemId"] 			= 75363,
		["internalLevel"]	= 50,
		["internalType"]	= 129,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75363:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75364] = {
		["level"] 			= 60,
		["itemId"] 			= 75364,
		["internalLevel"]	= 50,
		["internalType"]	= 134,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75364:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
	[75365] = {
		["level"] 			= 65,
		["itemId"] 			= 75365,
		["internalLevel"]	= 50,
		["internalType"]	= 308,
		["isPoison"] 		= true,
		["itemLink"]		= "|H0:item:75365:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	},
}

NUM_ALCHEMY_TRAITS = #internal.POTIONTRAIT_DATA

do
	-- generate localization based names for traits, reagents, solvents
	
	for i=1, NUM_ALCHEMY_TRAITS do
		internal.POTIONTRAIT_DATA[i].name 	= GetString("SI_LIBIJA_POTIONTRAIT", i)
		internal.POTIONTRAIT_DATA[i].name2	= GetString("SI_LIBIJA_POISONTRAIT", i)
	end
	
	local function getFormatedName(itemId)
		local linkFormat = "|H0:item:<<1>>:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
		local itemLink = zo_strformat(linkFormat, itemId)

		local itemName = GetItemLinkName(itemLink)
		return zo_strformat(SI_UNIT_NAME, itemName)
	end
	
	for itemId, reagentData in pairs(internal.REAGENT_DATA) do
		reagentData.name 	= getFormatedName(itemId)
	end
	
	for itemId, solventData in pairs(internal.SOLVENT_DATA) do
		solventData.name 	= getFormatedName(itemId)
	end
end

NUM_ALCHEMY_REAGENTS = NonContiguousCount(internal.REAGENT_DATA)

--	/script d(LibIJA.internal.REAGENT_DATA)