-------------------------------------
-- Custom result toolTip
-------------------------------------
local lib = LibIJA
local internal = lib.internal

local GENERAL_COLOR_WHITE = GAMEPAD_TOOLTIP_COLOR_GENERAL_COLOR_1
local GENERAL_COLOR_GREY = GAMEPAD_TOOLTIP_COLOR_GENERAL_COLOR_2
local GENERAL_COLOR_OFF_WHITE = GAMEPAD_TOOLTIP_COLOR_GENERAL_COLOR_3
local GENERAL_COLOR_RED = GAMEPAD_TOOLTIP_COLOR_FAILED

local FONT_SMALL	= "$(KB_16)"
local FONT_MED		= "$(KB_20)"
local FONT_LARGE	= "$(KB_25)"

internal_TOOLTIP_STYLES = {
	    --General
    tooltip = {
        width = ZO_GAMEPAD_CONTENT_WIDTH,
        paddingLeft = 15,
        paddingRight = 0,
        fontFace = "$(BOLD_FONT)",
        fontColorType = INTERFACE_COLOR_TYPE_GAMEPAD_TOOLTIP,
        fontColorField = GENERAL_COLOR_GREY,
        fontStyle = "soft-shadow-thick",
		layoutPrimaryDirectionCentered = true,
		horizontalAlignment = 1,
    },
    title = {
        fontSize = FONT_LARGE,
        customSpacing = 8,
        uppercase = true,
        fontColorField = GENERAL_COLOR_WHITE,
        widthPercent = 100,
    },
    statValueSeparatorSection = {
        fontSize = FONT_LARGE,
        fontFace = "$(BOLD_FONT)",
        fontColorField = GENERAL_COLOR_OFF_WHITE,
        uppercase = true,
        widthPercent = 100,
        horizontalAlignment = TEXT_ALIGN_CENTER
    },
    dividerLine = {
 --       textureCoordinateLeft = 0.25,
 --       textureCoordinateRight = 0.75,
 --       textureCoordinateTop = 0.25,
 --       textureCoordinateBottom = 0.75,
        widthPercent = 100,
--        height = 8,
        height = 6,
    },
    statValuePair = {
        height = 30,
    },
    statValuePairStat = { -- ""LEVEL"  "CP"
        fontSize = FONT_SMALL,
        uppercase = true,
        fontColorField = GENERAL_COLOR_OFF_WHITE,
    },
    statValuePairValue = {
        fontSize = FONT_LARGE,
        fontColorField = GENERAL_COLOR_WHITE,
    },
    statValuePairValueSmall = {
        fontSize = FONT_MED,
        fontColorField = GENERAL_COLOR_WHITE,
    },
    championRequirements = {
        fontSize = FONT_LARGE,
        fontColorField = GENERAL_COLOR_WHITE,
		layoutPrimaryDirectionCentered = true,
		horizontalAlignment = 1,
    },
    fullWidth = {
        widthPercent = 100
    },
    statValueSlider = {
        fontColorField = GENERAL_COLOR_WHITE,
        gradientColors = ZO_XP_BAR_GRADIENT_COLORS,
    },
    statValueSliderStat = {
        fontSize = FONT_SMALL,
        fontColorType = INTERFACE_COLOR_TYPE_TEXT_COLORS,
        fontColorField = INTERFACE_TEXT_COLOR_NORMAL,
    },
    statValueSliderValue = {
        fontSize = FONT_SMALL,
        fontColorField = GENERAL_COLOR_WHITE,
        gradientColors = ZO_XP_BAR_GRADIENT_COLORS,
    },
    succeeded = {
        fontColorField = GAMEPAD_TOOLTIP_COLOR_SUCCEEDED,
    },
    failed = {
        fontColorField = GAMEPAD_TOOLTIP_COLOR_FAILED,
    },
    bodySection = {
        customSpacing = 30,
        childSpacing = 20,
        widthPercent = 100,
        fontColorField = GENERAL_COLOR_OFF_WHITE,
        fontFace = "$(MEDIUM_FONT)",
		paddingTop = 0,
		paddingBottom = 0,
    },
    bodyHeader = {
        fontFace = "$(BOLD_FONT)",
        fontSize = FONT_SMALL,
        uppercase = true,
        fontColorField = GENERAL_COLOR_WHITE,
    },
    itemTagsSection = {
        customSpacing = 40,
        widthPercent = 100,
        fontFace = "$(MEDIUM_FONT)",
    },
    itemTradeBoPSection = {
        customSpacing = 80,
        widthPercent = 100,
        fontFace = "$(MEDIUM_FONT)",
    },
    itemTradeBoPHeader = {
        fontColor = ZO_TRADE_BOP_COLOR,
    },
    bodyDescription = {
        fontSize = FONT_MED,
    },
    whiteFontColor = {
        fontColorField = GENERAL_COLOR_WHITE,
    },

   --Item Tooltip
    baseStatsSection = { -- Level
        layoutPrimaryDirection = "right",
        layoutSecondaryDirection = "down",
        statValuePairSpacing = 3,
        childSpacing = 10,
        childSecondarySpacing = 3,
        widthPercent = 100,
		layoutPrimaryDirectionCentered = true,
		horizontalAlignment = 1,
    },
    valueStatsSection = {
        layoutPrimaryDirection = "right",
        layoutSecondaryDirection = "down",
		layoutPrimaryDirectionCentered = true,
        paddingTop = 30,
        widthPercent = 100,
		paddingBottom = 20,
		fontSize = FONT_SMALL,
    },
    topSection = { -- Potion/Poison
		fontSize = FONT_SMALL,
		fontColorField = GENERAL_COLOR_OFF_WHITE,
		layoutPrimaryDirection = "right",
		layoutSecondaryDirection = "down",
		widthPercent = 100,
		childSpacing = 0,
		customSpacing = 5,
		horizontalAlignment = 2,
--		layoutPrimaryDirectionCentered = true,
    },
    topSubsection = {
		layoutPrimaryDirection = "up",
		layoutSecondaryDirection = "right",
		height = 32,
		widthPercent = 100,
		childSpacing = 8,
		fontSize = FONT_SMALL,
    },
    topSubsectionItemDetails = {
		layoutPrimaryDirection = "up",
		layoutSecondaryDirection = "left",
		height = 0,
		widthPercent = 100,
		childSpacing = 15,
		fontSize = FONT_SMALL,
		fontColorField = GENERAL_COLOR_WHITE,
    },    
	flavorText =
    {
        fontSize = FONT_SMALL,
    },
    prioritySellText =
    {
        fontSize = "$(FONT_LARGE)",
    },
    inactiveBonus =
    {
        fontColorField = GAMEPAD_TOOLTIP_COLOR_INACTIVE,
    },
    activeBonus =
    {
        fontColorField = GENERAL_COLOR_OFF_WHITE,
    },
    degradedStat =
    {
        fontColorField = GAMEPAD_TOOLTIP_COLOR_FAILED,
    },
    qualityTrash =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_TRASH,
    },
    qualityNormal =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_NORMAL,
    },
    qualityMagic =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_MAGIC,
    },
    qualityArcane =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_ARCANE,
    },
    qualityArtifact =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_ARTIFACT,
    },
    qualityLegendary =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_LEGENDARY,
    },
    mythic =
    {
        fontColorType = INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS,
        fontColorField = ITEM_DISPLAY_QUALITY_MYTHIC_OVERRIDE,
    },
    bind = 
    {
        fontColorField = GENERAL_COLOR_OFF_WHITE,
    },
}

function IJA_StandardFloatingBottomScreenResizeHandler(control)
     local maxHeight = control:GetBottom() - ZO_GAMEPAD_FLOATING_SCROLL_SAFE_TOOLTIP_TOP_OFFSET
    control:SetDimensionConstraints(0, 0, 410, maxHeight)
end

function IJA_CraftingUtils_CraftingTooltip_Initialize(control, resizeHandler)
    local CRAFTING_TOOLTIP_OFFSET_X = -3
    IJA_ResizingFloatingTooltip_OnInitialized(control, ZO_CRAFTING_TOOLTIP_STYLES, resizeHandler)
end

do
    local ANCHORS_TO_BACKGROUND = true
	
	local function ResizingUpdateLoop(control)
		local contentHeight = control.tip:GetHeight()
		if not zo_floatsAreEqual(contentHeight, control.lastContentHeight) or control.forceResizeUpdate then
			control.lastContentHeight = contentHeight
			local totalHeight = contentHeight + ZO_GAMEPAD_FLOATING_SCROLL_TOOLTIP_TOP_ICON_PADDING_Y * 2
			control:SetDimensionConstraints(0, 0, 410, totalHeight)
			control.forceResizeUpdate = false
		end
	end

	local function ForceResizeUpdate(control)
		control.forceResizeUpdate = true
	end

	
    function IJA_ResizingFloatingTooltip_OnInitialized(control, tooltipStyles, screenResizeHandler)
        control.icon = control:GetNamedChild("Icon")
		
        local tooltip = control:GetNamedChild("ContainerTipTooltip")
		
		ZO_Tooltip:Initialize(tooltip, internal_TOOLTIP_STYLES, "tooltip")
		
        control.tip = tooltip
        control.tip.icon = control.icon
		
		if screenResizeHandler then
			control:RegisterForEvent(EVENT_SCREEN_RESIZED, function()
				screenResizeHandler(control)
				control.forceResizeUpdate = true
			end)

			control.lastContentHeight = 0
			control:SetHandler("OnUpdate", ResizingUpdateLoop)
			control:SetHandler("OnEffectivelyShown", ForceResizeUpdate)
			screenResizeHandler(control)

			control:SetHandler("OnMouseEnter", ResizingUpdateLoop)
        end
		
		ApplyTemplateToControl(control, "IJA_TooltipBorder")
		LibIJA.keyboardTooltip = control
				
		function control.tip:AddTopSection(itemLink)
			--Item Type Info
			local itemType, specializedItemType = GetItemLinkItemType(itemLink)
			local topSection = self:AcquireSection(self:GetStyle("topSection"))
			
			local specializedItemTypeText = ZO_GetSpecializedItemTypeText(itemType, specializedItemType)

			 self:AddTypeSlotUniqueLine(itemLink, itemType, topSection, specializedItemTypeText)
					
			self:AddTopLinesToTopSection(topSection, itemLink)
			self:AddSectionEvenIfEmpty(topSection)
		end
		
		function control.tip:LayoutAlchemyPreview(itemLink, itemTypeString, prospectiveAlchemyResult)
			if itemLink and itemLink ~= "" then
				if prospectiveAlchemyResult == PROSPECTIVE_ALCHEMY_RESULT_UNCRAFTABLE then
					if self.icon then
						self.icon:SetHidden(true)
					end
					local title, description
					if prospectiveAlchemyResult == PROSPECTIVE_ALCHEMY_RESULT_UNCRAFTABLE then
						title = zo_strformat(SI_ALCHEMY_NO_RESULT, itemTypeString)
						description = GetString(SI_ALCHEMY_NO_EFFECTS)
					else
						title = zo_strformat(SI_ALCHEMY_UNKNOWN_RESULT, itemTypeString)
						description = zo_strformat(SI_ALCHEMY_UNKNOWN_EFFECTS, itemTypeString)
					end
					self:AddLine(title, self:GetStyle("title"))
					local alchemySection = self:AcquireSection(self:GetStyle("bodySection"))
					alchemySection:AddLine(description, self:GetStyle("bodyDescription"))
					self:AddSection(alchemySection)
				else
					local icon = GetItemLinkIcon(itemLink)
					if self.icon then
						self.icon:SetTexture(icon)
						self.icon:SetHidden(false)
					end
					self:AddTopSection(itemLink)
					
					local separatorSection = self:AcquireSection(self:GetStyle("statValueSeparatorSection"))
					separatorSection:AddTexture("esoui/art/miscellaneous/horizontaldivider.dds", self:GetStyle("dividerLine"))
					
					self:AddItemTitle(itemLink)
					self:AddSection(separatorSection)
					self:AddBaseStats(itemLink)
					self:AddOnUseAbility(itemLink)
					self:UpdateGamepadBorderDisplay(itemLink)
					
					if GetItemLinkItemType(itemLink) == ITEMTYPE_POISON then
						self:AddPoisonSystemDescription()
					end
				
					internal:AddItemValue(self, itemLink)
				end
			end
		end
    end	
end

-------------------------------------
-- 
-------------------------------------
function internal:AddItemValue(control, itemLink)
    local statsSection = control:AcquireSection(control:GetStyle("valueStatsSection"))
    --Value
    local CONSIDER_CONDITION = true
    local value = GetItemLinkValue(itemLink, not CONSIDER_CONDITION)
    if value > 0 then
        local valueString = ZO_CommaDelimitNumber(value)
        local effectiveValue = GetItemLinkValue(itemLink, CONSIDER_CONDITION)
        local currencyIcon = ZO_Currency_GetKeyboardFormattedCurrencyIcon(CURT_MONEY, 16, ZO_CURRENCY_FORMAT_AMOUNT_ICON)
        local lineText
        if effectiveValue ~= value then
            local effectiveValueString = ZO_CommaDelimitNumber(effectiveValue)
            lineText = zo_strformat(SI_GAMEPAD_TOOLTIP_EFFECTIVE_ITEM_VALUE_FORMAT, effectiveValueString, valueString, currencyIcon)
        else
            lineText = zo_strformat(SI_GAMEPAD_TOOLTIP_ITEM_VALUE_FORMAT, valueString, currencyIcon)
        end
        statsSection:AddLine(lineText, control:GetStyle("statValuePairValueSmall"))
    end
    control:AddSection(statsSection)
end

local function isKnown(prospectiveAlchemyResult)
	return prospectiveAlchemyResult == PROSPECTIVE_ALCHEMY_RESULT_KNOWN and true or false
end

local function SetUnknownTraitHidden(prospectiveAlchemyResult)
 	local recipeKnown = prospectiveAlchemyResult == PROSPECTIVE_ALCHEMY_RESULT_KNOWN and true or false

	if recipeKnown then
		LibIJA.tooltip:GetNamedChild('Notice'):SetEdgeTexture("EsoUI/Art/Tooltips/UI-Border.dds", 128, 16)
	else
		LibIJA.tooltip:GetNamedChild('Notice'):SetEdgeTexture("EsoUI/Art/Crafting/crafting_toolTip_glow_edge_red64.dds", 128, 32)
	end
end

function internal:UpdateTooltip(resultType, traitIds, solventItemId)
--	lib.useTooltip = false
	if not lib:IsShowingAlchemyCraftingScene()	then return end
	ApplyTemplateToControl(lib.tooltip, "IJA_TooltipBorder")

 	lib.tooltip:SetHidden(false)
	lib.tooltip.tip:ClearLines()
	
	local itemLink, prospectiveAlchemyResult = internal:GetAlchemyResultingItemLink()
	
	if resultType and traitIds and solventItemId then
		itemLink = internal:GetAlchemyResultLink(resultType, traitIds, solventItemId)

	elseif not isKnown(prospectiveAlchemyResult) then
		itemLink = internal:GetAlchemyResultLink(internal:GetTooltipData())
	end
	
	local itemTypeString = GetString(resultType == 1 and SI_ITEM_FORMAT_STR_POTION or SI_ITEM_FORMAT_STR_POISON)
	-- itemTypeString, PROSPECTIVE_ALCHEMY_RESULT_KNOWN) is for the gamepad tooltip
	lib.tooltip.tip:LayoutAlchemyPreview(itemLink, itemTypeString, prospectiveAlchemyResult)
	SetUnknownTraitHidden(prospectiveAlchemyResult)
end
--[[


create reset manual functions
local function useManual()
	if then
	end
end

ZO_PostHook(ALCHEMY, 'SetReagentItem', useManual)
ZO_PostHook(ALCHEMY, 'SetSolventItem', useManual)

function ZO_SharedAlchemy:SetReagentItem(reagentSlot, bagId, slotIndex)

function ZO_SharedAlchemy:SetSolventItem(bagId, slotIndex)

/script ZO_PostHook(ALCHEMY, 'SetSolventItem', function(...) d(...) end)


|H0:item:44815:308:50:0:0:0:0:0:0:0:0:0:0:0:0:36:0:0:0:0:4|h|h

|H0:item:30142:30:20:0:0:0:0:0:0:0:0:0:0:0:0:36:0:0:0:0:2162688|h|h


-- /script d("|H0:item:44815:308:50:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:4|h|h")
-- /script d("|H0:item:30142:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h")
|H1:item:27041:308:50:0:0:0:0:0:0:0:0:0:0:0:0:36:1:0:0:0:1507328|h|h


/script d("|H1:item:27041:308:50:0:0:0:0:0:0:0:0:0:0:0:0:36:1:0:0:0:1507328|h|h")
-- /script d("|H0:item:27041:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:23|h|h")
-- /script d("|H0:item:27041:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h")
-- /script d("|H0:item:27041:308:50:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h")
-- /script d("|H0:item:27041:30:20:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:5915|h|h")


-- /script d("|H0:item:27041:30:20:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:2293760|h|h")
-- /script d("|H0:item:76848:30:20:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:2293760|h|h")

--]]